# CustomDataSource

#### new Cesium.CustomDataSource(name)
DataSources/CustomDataSource.js 28

A `DataSource` implementation which can be used to manually manage a group of entities.

Name | Type | Description
--- | --- | ---
`name` | String | optional A human-readable name for this instance.

##### Example:

    var dataSource = new Cesium.CustomDataSource('myData');

    var entity = dataSource.entities.add({
       position : Cesium.Cartesian3.fromDegrees(1, 2, 0),
       billboard : {
           image : 'image.png'
       }
    });

    viewer.dataSources.add(dataSource);

### Members

#### changedEvent : Event
DataSources/CustomDataSource.js 100

Gets an event that will be raised when the underlying data changes.

#### clock : DataSourceClock
DataSources/CustomDataSource.js 61

Gets or sets the clock for this instance.

#### clustering : EntityCluster
DataSources/CustomDataSource.js 145

Gets or sets the clustering options for this data source. This object can be shared between multiple data sources.

#### entities : EntityCollection
DataSources/CustomDataSource.js 77

Gets the collection of `Entity` instances.

#### errorEvent : Event
DataSources/CustomDataSource.js 110

Gets an event that will be raised if an error is encountered during processing.

#### isLoading : Boolean
DataSources/CustomDataSource.js 87

Gets or sets whether the data source is currently loading data.

#### loadingEvent : Event
DataSources/CustomDataSource.js 120

Gets an event that will be raised when the data source either starts or stops loading.

#### name : String
DataSources/CustomDataSource.js 45

Gets or sets a human-readable name for this instance.

#### show : Boolean
DataSources/CustomDataSource.js 130

Gets whether or not this data source should be displayed.

### Methods

#### update(time) → Boolean
DataSources/CustomDataSource.js 169

Updates the data source to the provided time. This function is optional and is not required to be implemented. It is provided for data sources which retrieve data based on the current animation time or scene state. If implemented, update will be called by `DataSourceDisplay` once a frame.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The simulation time.

##### Returns:

True if this data source is ready to be displayed at the provided time, false otherwise.